target          EQU   'T3'                      ; Target assembler: TASM-3.2
.486

data_1e         equ     44Ah
data_2e         equ     44Ch
data_3e         equ     463h
data_4e         equ     484h
data_26e        equ     4A4h                    ;*

seg_a           segment byte public use16
                assume  cs:seg_a, ds:seg_a


                org     100h

vgafade         proc    far

start:
                xor     bx,bx                   ; Zero register
                xor     cx,cx                   ; Zero register
                xor     dx,dx                   ; Zero register
                mov     ax,3
                int     33h                     ; Mouse driver    ax=func 0003h
                                                ;  get position, cx=horz,dx=vert
                                                ;   bx=mouse button status bits
                mov     data_6,bx
                mov     data_7,cx
                mov     data_8,dx
                xor     ax,ax                   ; Zero register
                mov     es,ax
                mov     ah,0B8h
                mov     dx,es:data_3e
                cmp     dx,3D4h
                je      short loc_1             ; Jump if equal
                mov     ah,0B0h
loc_1:
                mov     data_9,ax
                mov     ax,es:data_1e
                mov     data_11,ax
                mov     ax,es:data_2e
                shr     ax,1                    ; Shift w/zeros fill
                mov     data_13,ax
                mov     al,es:data_4e
                inc     al
                mov     ah,0
                mov     data_12,ax
                add     dl,6
                mov     bx,dx
                push    cs
                pop     es
                mov     di,offset data_18
                mov     si,di
                cld                             ; Clear direction
                mov     cx,10h
                push    cx

locloop_2:
                mov     dx,bx
                in      al,dx                   ; port 3DAh, CGA/EGA vid status
                mov     dx,3C0h
                mov     al,10h
                sub     al,cl
                out     dx,al                   ; port 3C0h, EGA attributes
                inc     dx
                insb                            ; Port dx to es:[di]
                dec     dx
                loop    locloop_2               ; Loop if cx > 0

                xchg    dx,bx
                in      al,dx                   ; port 3DAh, CGA/EGA vid status
                xchg    dx,bx
                mov     al,20h                  ; ' '
                out     dx,al                   ; port 3C0h, EGA attributes
                mov     data_10,bx
                mov     dl,0C7h
                mov     di,offset data_21
                push    di
                mov     cx,10h

locloop_3:
                lodsb                           ; String [si] to al
                out     dx,al                   ; port 3C7h, VGA pel address
                inc     dx
                inc     dx
                insb                            ; Port dx to es:[di]
                insb                            ; Port dx to es:[di]
                insb                            ; Port dx to es:[di]
                dec     dx
                dec     dx
                loop    locloop_3               ; Loop if cx > 0

                pop     si
                mov     al,0
                call    sub_4
                mov     cx,data_13
                push    cx
                mov     ds,data_9
                xor     si,si                   ; Zero register
                mov     di,data_26e
                rep     movsw                   ; Rep when cx >0 Mov [si] to es:[di]
                push    ds
                pop     es
                pop     cx
                xor     si,si                   ; Zero register
                xor     di,di                   ; Zero register

locloop_4:
                inc     si
                inc     di
                lodsb                           ; String [si] to al
                mov     ah,al
                shr     ah,4                    ; Shift w/zeros fill
                and     al,0Fh
                mov     bx,offset data_25
                xlat    cs:[bx]                 ; al=[al+[bx]] table
                xchg    ah,al
                xlat    cs:[bx]                 ; al=[al+[bx]] table
                shl     al,4                    ; Shift w/zeros fill
                or      al,ah
                stosb                           ; Store al to es:[di]
                loop    locloop_4               ; Loop if cx > 0

                push    cs
                pop     ds
                mov     si,offset data_23
                call    sub_1
                mov     dx,41h
                mov     bx,data_11
                sub     bx,8
                call    sub_2
                shl     bx,1                    ; Shift w/zeros fill
                mov     data_16,bx
                and     ax,0FFFEh
                mov     data_14,ax
                mov     dx,40h
                mov     bx,data_12
                sub     bx,4
                call    sub_2
                mov     data_17,bx
                mov     data_15,ax
loc_5:
                call    sub_5
                mov     cx,4
                mov     dx,data_10

locloop_6:
                in      al,dx                   ; port 0, DMA-1 bas&add ch 0
                test    al,8
                jnz     locloop_6               ; Jump if not zero
loc_7:
                in      al,dx                   ; port 0, DMA-1 bas&add ch 0
                test    al,8
                jz      loc_7                   ; Jump if zero
                loop    locloop_6               ; Loop if cx > 0

                call    sub_6
                mov     ax,data_14
                mov     bx,data_11
                sub     bx,7
;*              and     bx,0FFFEh
                db       83h,0E3h,0FEh          ;  Fixup - byte match
                cmp     ax,bx
                jb      short loc_8             ; Jump if below
                mov     data_16,0FFFEh
loc_8:
                or      ax,ax                   ; Zero ?
                jg      short loc_9             ; Jump if >
                mov     data_16,2
loc_9:
                add     ax,data_16
                mov     data_14,ax
                mov     ax,data_15
                mov     bx,data_12
                sub     bx,4
                cmp     ax,bx
                jb      short loc_10            ; Jump if below
                mov     data_17,0FFFFh
loc_10:
                or      ax,ax                   ; Zero ?
                jg      short loc_11            ; Jump if >
                mov     data_17,1
loc_11:
                add     ax,data_17
                mov     data_15,ax
                xor     bx,bx                   ; Zero register
                xor     cx,cx                   ; Zero register
                xor     dx,dx                   ; Zero register
                mov     ax,3
                int     33h                     ; Mouse driver    ax=func 0003h
                                                ;  get position, cx=horz,dx=vert
                                                ;   bx=mouse button status bits
                cmp     bx,data_6
                jne     short loc_13            ; Jump if not equal
                cmp     cx,data_7
                jne     short loc_13            ; Jump if not equal
                cmp     dx,data_8
                jne     short loc_13            ; Jump if not equal
                mov     ah,1
                int     16h                     ; Keyboard i/o  ah=function 01h
                                                ;  get status, if zf=0  al=char
                jnz     short loc_12            ; Jump if not zero
                jmp     loc_5
loc_12:
                mov     ax,0C0Bh
                int     21h                     ; DOS Services  ah=function 0Ch
                                                ;  clear keybd buffer & input al
loc_13:
                call    sub_6
                mov     si,offset data_22
                call    sub_1
                mov     cx,data_13
                mov     es,data_9
                mov     si,data_26e
                xor     di,di                   ; Zero register
                rep     movsw                   ; Rep when cx >0 Mov [si] to es:[di]
                push    cs
                pop     es
                mov     al,1
                call    sub_4
                int     20h                     ; DOS program terminate

vgafade         endp

;
;                              SUBROUTINE
;

sub_1           proc    near
                mov     cx,4
                mov     bx,offset data_19
                mov     dx,3C8h

locloop_14:
                mov     al,[bx]
                inc     bx
                out     dx,al                   ; port 3C8h, VGA pel address
                inc     dx
                outsb                           ; Out [si] to port dx
                outsb                           ; Out [si] to port dx
                outsb                           ; Out [si] to port dx
                dec     dx
                loop    locloop_14              ; Loop if cx > 0

                retn
sub_1           endp


;
;                              SUBROUTINE
;

sub_2           proc    near
                in      al,dx                   ; port 41h, 8253 timer 1 refsh
                mov     ah,al
                in      al,dx                   ; port 41h, 8253 timer 1 refsh
                and     ax,3FFh
loc_15:
                cmp     ax,bx
                jb      short loc_16            ; Jump if below
                sub     ax,bx
                jmp     short loc_15
loc_16:
                shr     bx,1                    ; Shift w/zeros fill
                cmp     ax,bx
                mov     bx,0FFFFh
                ja      short loc_ret_17        ; Jump if above
                neg     bx

loc_ret_17:
                retn
sub_2           endp


;
;                              SUBROUTINE
;

sub_3           proc    near
                mov     ah,10h
                mov     bx,offset data_18
                mov     dx,data_10
loc_18:
                in      al,dx                   ; port 0, DMA-1 bas&add ch 0
                test    al,8
                jnz     loc_18                  ; Jump if not zero
loc_19:
                in      al,dx                   ; port 0, DMA-1 bas&add ch 0
                test    al,8
                jz      loc_19                  ; Jump if zero
loc_20:
                mov     al,[bx]
                inc     bx
                mov     dl,0C8h
                out     dx,al                   ; port 0C8h, DMA-2 bas&add ch 2
                inc     dx
                mov     cl,3
                rep     outsb                   ; Rep when cx >0 Out [si] to port dx
                dec     ah
                jnz     loc_20                  ; Jump if not zero
                retn
sub_3           endp


;
;                              SUBROUTINE
;

sub_4           proc    near
                mov     data_5,al
                mov     bp,3Fh
loc_21:
                mov     si,offset data_21
                mov     di,offset data_20
                mov     cx,30h
                mov     bx,bp
                cmp     byte ptr data_5,0
                je      short locloop_22        ; Jump if equal
                mov     bx,40h
                sub     bx,bp

locloop_22:
                lodsb                           ; String [si] to al
                mov     bh,[si+2Fh]
                sub     al,bh
                imul    bl                      ; ax = reg * al
                sar     ax,6                    ; Shift w/sign fill
                add     al,bh
                stosb                           ; Store al to es:[di]
                loop    locloop_22              ; Loop if cx > 0

                mov     si,offset data_20
                call    sub_3
                dec     bp
                jge     loc_21                  ; Jump if > or =
                retn
sub_4           endp

data_5          db      0

;
;                              SUBROUTINE
;

sub_5           proc    near
                mov     ax,data_15
                mov     bp,data_11
                shl     bp,1                    ; Shift w/zeros fill
                mul     bp                      ; dx:ax = reg * ax
                sub     bp,0Eh
                mov     bx,data_14
                shl     bx,1                    ; Shift w/zeros fill
                add     ax,bx
                inc     ax
                mov     di,ax
                mov     si,offset data_24
                mov     bl,4
loc_23:
                mov     cx,7

locloop_24:
                lodsb                           ; String [si] to al
                mov     ah,es:[di]
                or      al,al                   ; Zero ?
                jz      short loc_25            ; Jump if zero
                and     ah,0F0h
loc_25:
                or      al,ah
                stosb                           ; Store al to es:[di]
                inc     di
                loop    locloop_24              ; Loop if cx > 0

                add     di,bp
                dec     bl
                jnz     loc_23                  ; Jump if not zero
                retn
sub_5           endp


;
;                              SUBROUTINE
;

sub_6           proc    near
                mov     ax,data_15
                mov     bp,data_11
                shl     bp,1                    ; Shift w/zeros fill
                mul     bp                      ; dx:ax = reg * ax
                sub     bp,0Eh
                mov     bx,data_14
                shl     bx,1                    ; Shift w/zeros fill
                add     ax,bx
                inc     ax
                mov     di,ax
                mov     si,ax
                add     si,data_26e
                mov     dl,4
loc_26:
                mov     cx,7

locloop_27:
                lodsb                           ; String [si] to al
                inc     si
                mov     ah,al
                shr     ah,4                    ; Shift w/zeros fill
                and     al,0Fh
                mov     bx,offset data_25
                xlat    cs:[bx]                 ; al=[al+[bx]] table
                xchg    ah,al
                xlat    cs:[bx]                 ; al=[al+[bx]] table
                shl     al,4                    ; Shift w/zeros fill
                or      al,ah
                stosb                           ; Store al to es:[di]
                inc     di
                loop    locloop_27              ; Loop if cx > 0

                add     di,bp
                add     si,bp
                dec     dl
                jnz     loc_26                  ; Jump if not zero
                retn
sub_6           endp

data_6          dw      0
data_7          dw      0
data_8          dw      0
data_9          dw      0
data_10         dw      0
data_11         dw      0
data_12         dw      0
data_13         dw      0
data_14         dw      0
data_15         dw      0
data_16         dw      0
data_17         dw      0
data_18         dw      4 dup (0)
                db      0
data_19         db      0
                db      0, 0, 0, 0, 0, 0
data_20         db      0
                db      47 dup (0)
data_21         db      0
                db      51 dup (0)
                db      1, 2, 0, 2, 4
data_22         db      0
                db       03h, 06h, 00h, 04h, 08h, 00h
                db       05h, 0Ah, 00h, 06h, 0Ch, 00h
                db       07h, 0Eh, 00h, 02h, 04h, 00h
                db       03h, 06h, 00h, 04h, 08h, 00h
                db       05h, 0Ah, 00h, 06h, 0Ch, 00h
                db       07h, 0Eh, 00h, 08h, 10h, 00h
                db       09h, 12h
data_23         db      14h
                db       14h, 14h, 19h, 19h, 19h, 1Eh
                db       1Eh, 1Eh
                db       23h, 23h, 23h
data_24         db      0
                db       09h, 0Ah, 0Bh, 0Ah, 09h, 00h
                db       09h, 0Ah, 0Bh, 0Ch, 0Bh, 0Ah
                db       09h, 09h, 0Ah, 0Bh, 0Ch, 0Bh
                db       0Ah, 09h, 00h, 09h, 0Ah, 0Bh
                db       0Ah, 09h, 00h
data_25         db      0
                db       01h, 02h, 03h, 04h, 05h, 06h
                db       07h, 02h, 03h, 04h, 05h, 06h
                db       07h, 0Eh, 0Fh

seg_a           ends
                end     start
