#include <DOS.H>
#include <STRING.H>
#include <STDIO.H>
#include <IO.H>
#include <IOSTREAM.H>

class TBootSector {
private:
      char disk;
public:
      char data[511];

      TBootSector(void);
      ~TBootSector(void);
      void SetDisk(char ch);
      int LoadCode(char * name);
      int Write(void);
};

//  ###############################################################
TBootSector::TBootSector(void)
 {
  memset(&data,0,512);
 }

//  ################################################################
TBootSector::~TBootSector(void) {}

//  ࠡ稩  #######################################################
void TBootSector::SetDisk(char ch)
 {
  disk=0;
  if (ch>'A' && ch<'Z') {disk=disk-'A';}
  if (ch>'a' && ch<'z') {disk=disk-'a';}
 }

//  ᥪ ###########################################################
int TBootSector::Write(void)
 {
    int Ofs=FP_OFF(data);
    int Segm=FP_SEG(data);
    char Disk=disk;

   _asm {
         push  ds
         mov   ax,[Segm]         //  
         mov   ds,ax
         mov   bx,[Ofs]          // 饭 
         mov   al,[Disk]         //  ᪠
         mov   cx,1              // 稪 뢠 ᨬ
         mov   dx,0              // 砫 ᥪ

         int   0x26
         pop   dx
         pop   ds
         je    nError
        }
    cout<<"  boot ᥪ ந ᯥ譮."<<endl;
    return(0);
nError:
    cout<<"訡   boot ᥪ."<<endl;
    return(_AX);
}

// 㧪  #############################################################
int TBootSector::LoadCode(char * name)
 {
  FILE *f;

  if ((f=fopen(name,"rb"))!=NULL)
   {
    fseek(f,0x7B00,SEEK_SET);       // 7C00h - 100h
    fread(data,512,1,f);
    cout<<" ⠭ ଠ쭮."<<endl;
    fclose(f);
   } else {cout<<"訡 ⥭ 䠩"<<endl;return(1);}
   return(0);
 }

int main(void)
 {
  class TBootSector boot;

  boot.SetDisk(65);
  if (boot.LoadCode("boot/boot.com")==0)
   {
    if (boot.Write()==0) return(0);
                    else return(2);
   } else return(1);

 }